package com.luojigou.xiaodou.ble

import android.annotation.SuppressLint
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.collection.ArraySet
import androidx.recyclerview.widget.RecyclerView
import com.luojigou.xiaodou.R


@SuppressLint("MissingPermission")
class XDScanBLEAdapter(
    private val itemClickListener: (XDScanBLEDevice) -> Unit,
) : RecyclerView.Adapter<XDScanBLEAdapter.ViewHolder>() {
    private val list: MutableSet<XDScanBLEDevice> = ArraySet()

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val itemView: View =
            LayoutInflater.from(parent.context).inflate(R.layout.item_ble, parent, false)
        return ViewHolder(itemView)
    }

    override fun getItemCount(): Int = list.size

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val item = list.elementAt(position)

        holder.apply {
            name.text = item.name
            bondState.text = item.bondState
            rssi.text = item.rssi
            address.text = item.address
            addressType.text = item.addressType
        }

        holder.itemView.setOnClickListener {
            itemClickListener(item)
        }
    }

    @SuppressLint("NotifyDataSetChanged")
    fun setValues(values: List<XDScanBLEDevice>) {
        list.clear()
        list.addAll(values)
        notifyDataSetChanged()
    }

    fun addValue(value: XDScanBLEDevice) {
        list.add(value)
        notifyItemChanged(list.size - 1)
    }

    class ViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val img = itemView.findViewById<ImageView>(R.id.iv_ble)
        val id = itemView.findViewById<TextView>(R.id.tv_ble_id)
        val name = itemView.findViewById<TextView>(R.id.tv_ble_name)
        val bondState = itemView.findViewById<TextView>(R.id.tv_ble_bond_tate)
        val rssi = itemView.findViewById<TextView>(R.id.tv_ble_rssi)
        val address = itemView.findViewById<TextView>(R.id.tv_ble_address)
        val addressType = itemView.findViewById<TextView>(R.id.tv_ble_address_type)
    }
}