package com.luojigou.xiaodou.wifi

import android.content.Intent
import android.net.wifi.WifiManager
import android.os.Build
import android.os.Bundle
import android.provider.Settings
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import androidx.activity.result.ActivityResultLauncher
import androidx.activity.result.contract.ActivityResultContracts
import androidx.fragment.app.Fragment
import com.luojigou.xiaodou.R

class XDScanWifiDisableFragment(private val host: XDScanWifiStatus.Host) : Fragment() {
    private val openWifi: ActivityResultLauncher<Intent> =
        registerForActivityResult(ActivityResultContracts.StartActivityForResult()) {
            host.onStatusChanged(XDScanWifiStatus.Disabled)
        }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?
    ): View {
        return inflater.inflate(R.layout.fragment_scanwifi_disable, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val button = view.findViewById<Button>(R.id.btn_open)
        button.setOnClickListener { checkAndOpenWifi() }
    }

    private fun checkAndOpenWifi() {
        if (host.getWifiManager().wifiState == WifiManager.WIFI_STATE_DISABLED) {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.Q) {
                openWifi.launch(Intent(Settings.Panel.ACTION_WIFI))
            } else {
                host.getWifiManager().setWifiEnabled(true)
                host.onStatusChanged(XDScanWifiStatus.Disabled)
            }
        }
    }
}